// Registry.h : main header file for the Registry class
//

#pragma once

#undef DECL
#ifdef UTILS_DLL
#define DECL _declspec(dllexport)
#else
#define DECL _declspec(dllimport)
#endif

// Static class providing path related services (a la the Path class in .NET Framework)
class DECL Registry
{
   public:
   
   // These open and close key for you
   static DWORD GetDWORD(HKEY hHiveKey, const CString& strSection, const CString& strItem, DWORD dwDefault);
   static bool SetDWORD(HKEY hHiveKey, const CString& strSection, const CString& strItem, DWORD dwValue);
   static CString GetString(HKEY hHiveKey, const CString& strSection, const CString& strItem, CString strDefault);
   static bool SetString(HKEY hHiveKey, const CString& strSection, const CString& strItem, const CString& strValue);
   static bool GetMultiString(HKEY hHiveKey, const CString& strSection, const CString& strItem, CStringArray& saResult);
   static bool SetMultiString(HKEY hHiveKey, const CString& strSection, const CString& strItem, const CStringArray& strValues);

   // Open, create, and close key manually
   static HKEY OpenKey(HKEY hHiveKey, const CString& strSection);
   static HKEY CreateKey(HKEY hHiveKey, const CString& strSection);
   static bool CloseKey(HKEY hHiveKey);

   // Caller should open (or create) and close key around use
   static DWORD GetDWORD(HKEY hSectionKey, const CString& strItem, DWORD dwDefault);
   static bool SetDWORD(HKEY hSectionKey, const CString& strItem, DWORD dwValue);
   static CString GetString(HKEY hSectionKey, const CString& strItem, CString strDefault);
   static bool SetString(HKEY hSectionKey, const CString& strItem, const CString& strValue);
   static bool GetMultiString(HKEY hSectionKey, const CString& strItem, CStringArray& saResult);
   static bool SetMultiString(HKEY hSectionKey, const CString& strItem, const CStringArray& strValues);

   // Delete an entire node, i.e., key and all its sub-keys. 
   static bool DeleteNode(HKEY hKeyRoot, LPCTSTR lpSubKey);

private:
   static bool DeleteNodeRecurse(HKEY hKeyRoot, LPTSTR lpSubKey);
};
